#include <Stepper.h>
#include <Servo.h>
#include <avr/wdt.h>

void arm_start() {
  //asm volatile (" jmp 0");
  int value;
  int start_step = 100;
  int end_step = 80;
  int check_step = 1;
  int step = 10;
  int speed = 10;
  int around_step = 400;
  Servo myservo;
  Stepper myStepper_s(around_step,A0,A3,A2,A1);
  Stepper myStepper_e(around_step,A0,A3,A1,A2);
  Stepper myStepper_c(around_step,A0,A3,A1,A2);
  Serial.begin(9600);
  myStepper_s.setSpeed(speed);
  myStepper_e.setSpeed(speed);
  myStepper_c.setSpeed(speed);
  myservo.attach(SV_PIN, 500, 2400);
  

  value = digitalRead(DIN_PIN);
  if(value == LOW){
    //stepping
    myStepper_s.step(start_step);
    delay(1000);
    //servo
    myservo.write(135);  //servo_angle of rotation
    delay(1000);
  }
  software_reset();
  exit(0);
}


void arm_end() {
  //asm volatile (" jmp 0");
  int value;
  int start_step = 100;
  int end_step = 80;
  int check_step = 1;
  int step = 10;
  int speed = 10;
  int around_step = 400;
  Servo myservo;
  Stepper myStepper_s(around_step,A0,A3,A2,A1);
  Stepper myStepper_e(around_step,A0,A3,A1,A2);
  Stepper myStepper_c(around_step,A0,A3,A1,A2);
  Serial.begin(9600);
  myStepper_s.setSpeed(speed);
  myStepper_e.setSpeed(speed);
  myStepper_c.setSpeed(speed);
  myservo.attach(SV_PIN, 500, 2400);
  //pinMode(DIN_PIN, INPUT_PULLUP);

  value = digitalRead(DIN_PIN);
  if(value == HIGH){
    //servo
    myservo.write(95);  //servo_angle of rotation
    delay(1000);
    //stepping
    myStepper_e.step(end_step);

    while(1){
      value = digitalRead(DIN_PIN);
      if(value == HIGH){
        myStepper_c.step(check_step);
        delay(10);
      }
      else{
        break;
      }  
    }
  }
  software_reset();
  exit(0);
}




void software_reset(){
  wdt_disable();
  wdt_enable(WDTO_15MS);
  while(1){}
}





